//  playimage.inc

constructor TPlayImage.Create(aInfo:TPlayInfo; aHeight:integer);
begin
  inherited Create(aInfo);
  Parent := aInfo;
  FCont := AInfo.FCont;
  Name := 'Image_'+IntToStr(aInfo.FIndex);
  Autosize := true;
  Constraints.MaxHeight := aHeight;
  Constraints.MinHeight := aHeight;
  Constraints.MaxWidth := aHeight;
  Proportional := true;
  Stretch := true;
  StretchInEnabled := true;
  AnchorSide[akLeft].Side := asrLeft;
  AnchorSide[akLeft].Control := aInfo;
  AnchorSide[akTop].Side := asrTop;
  AnchorSide[akTop].Control := aInfo;
  AnchorSide[akBottom].Side := asrBottom;
  AnchorSide[akBottom].Control := aInfo;
  BorderSpacing.Left := 4;
  BorderSpacing.Around := 1;
  Anchors := [akLeft, akTop, akBottom];
  DragMode := dmManual;
  DragKind := dkDrag;
end;

procedure TPlayImage.MouseEnter;
begin
  FCont.Hover := TPlayInfo(Parent).FIndex;
  if Assigned(FCont.OnMouseEnter) then FCont.OnMouseEnter(Self);
end;

procedure TPlayImage.MouseLeave;
begin
  FCont.Hover := -1;
  if Assigned(FCont.OnMouseLeave) then FCont.OnMouseLeave(Self);
end;

procedure TPlayImage.MouseDown(aButton:TMouseButton; aShift:TShiftState; aX,aY: Integer);
begin
  FCont.Selected := TPlayInfo(Parent).FIndex;
  FCont.FMouseIndex := TPlayInfo(Parent).FIndex;
  if Assigned(FCont.OnMouseDown) then FCont.OnMouseDown(Self, aButton, aShift, aX, aY)
end;

procedure TPlayImage.MouseMove(aShift:TShiftState; aX,aY: Integer);
begin
  if Assigned(FCont.OnMouseMove) then FCont.OnMouseMove(Self, aShift, aX, aY)
end;

procedure TPlayImage.MouseUp(aButton:TMouseButton; aShift:TShiftState; aX,aY:Integer);
begin
  FCont.Hover := TPlayInfo(Parent).FIndex;
  if Assigned(FCont.OnMouseUp) then FCont.OnMouseUp(Self, aButton, aShift, aX, aY)
end;

procedure TPlayImage.DragOver(aSource:TObject; aX,aY:Integer; aState: TDragState; var Accept:Boolean);
begin
  if Assigned(FCont.OnDragOver) then begin
    FCont.DropIndex := TPlayInfo(Parent).FIndex;
    FCont.OnDragOver(FCont, aSource, aX, aY, aState, Accept);
    if not Accept then FCont.DropIndex := -1;
  end;
end;

procedure TPlayImage.DragDrop(aSource:TObject; aX,aY:Integer);
begin
  if Assigned(FCont.OnDragDrop) then FCont.OnDragDrop(FCont, aSource, aX, aY);
end;

