// playlabel.inc

constructor TPlayLabel.Create(aInfo:TPlayInfo; aImg:TPlayImage);
begin
  inherited Create(aInfo);
  Parent := aInfo;
  FCont := AInfo.FCont;
  Name := 'Info_'+IntToStr(aInfo.FIndex);
  AutoSize := false;
  Caption := 'Test';
  ShowAccelChar := false;
  AnchorSide[akLeft].Side := asrRight;
  AnchorSide[akLeft].Control := aImg;
  AnchorSide[akTop].Side := asrTop;
  AnchorSide[akTop].Control := aInfo;
  AnchorSide[akRight].Side := asrRight;
  AnchorSide[akRight].Control := aInfo;
  AnchorSide[akBottom].Side := asrBottom;
  AnchorSide[akBottom].Control := aInfo;
  BorderSpacing.Left := 4;
  BorderSpacing.Right := 4;
  BorderSpacing.Around := 1;
  Anchors := [akLeft, akTop, akRight, akBottom];
  DragMode := dmManual;
  DragKind := dkDrag;
end;

procedure TPlayLabel.MouseEnter;
begin
  FCont.Hover := TPlayInfo(Parent).FIndex;
  if Assigned(FCont.OnMouseEnter) then FCont.OnMouseEnter(Self);
end;

procedure TPlayLabel.MouseLeave;
begin
  FCont.Hover := -1;
  if Assigned(FCont.OnMouseLeave) then FCont.OnMouseLeave(Self);
end;

procedure TPlayLabel.MouseDown(aButton:TMouseButton; aShift:TShiftState; aX,aY: Integer);
begin
  FCont.FMouseIndex := TPlayInfo(Parent).FIndex;
  FCont.Selected := TPlayInfo(Parent).FIndex;
  if Assigned(FCont.OnMouseDown) then FCont.OnMouseDown(Self, aButton, aShift, aX, aY)
end;

procedure TPlayLabel.MouseMove(aShift:TShiftState; aX,aY: Integer);
begin
  if Assigned(FCont.OnMouseMove) then FCont.OnMouseMove(Self, aShift, aX, aY)
end;

procedure TPlayLabel.MouseUp(aButton:TMouseButton; aShift:TShiftState; aX,aY:Integer);
begin
  FCont.Hover := TPlayInfo(Parent).FIndex;
  if Assigned(FCont.OnMouseUp) then FCont.OnMouseUp(Self, aButton, aShift, aX, aY)
end;

procedure TPlayLabel.DragOver(aSource:TObject; aX,aY:Integer; aState: TDragState; var Accept:Boolean);
begin
  if Assigned(FCont.OnDragOver) then begin
    FCont.DropIndex := TPlayInfo(Parent).FIndex;
    FCont.OnDragOver(FCont, aSource, aX, aY, aState, Accept);
    if not Accept then FCont.DropIndex := -1;
  end;
end;

procedure TPlayLabel.DragDrop(aSource:TObject; aX,aY:Integer);
begin
  if Assigned(FCont.OnDragDrop) then FCont.OnDragDrop(FCont, aSource, aX, aY);
end;

