//  playpanel.inc

constructor TPlayHeader.Create(aCont:TPlayContainer; aScrW:integer);
begin
  inherited Create(aCont);
  Parent := aCont;
  AutoSize := false;
  Alignment := taCenter;
  Layout := tlCenter;
  ShowAccelChar := false;
  Caption := aCont.Header;
  Height := aCont.HeaderHeight;
  Color := aCont.HeaderColor;
  AnchorSide[akLeft].Side := asrLeft;
  AnchorSide[akLeft].Control := aCont;
  AnchorSide[akTop].Side := asrTop;
  AnchorSide[akTop].Control := aCont;
  AnchorSide[akRight].Side := asrRight;
  AnchorSide[akRight].Control := aCont;
  BorderSpacing.Right := aScrW+2;
  BorderSpacing.Around := 0;
  Anchors := [akLeft, akTop, akRight];
  DragMode := dmManual;
  DragKind := dkDrag;
  dx := -1;
  dY := -1;
end;

procedure TPlayHeader.DragOver(aSource:TObject; aX,aY:Integer; aState: TDragState; var Accept:Boolean);
begin  // scroll up if dragged over
  Accept := false;
  if (aState = dsDragEnter) or (dX < 0) or (dY < 0) then begin
    dX := aX;
    dY := aY;
  end else if aState = dsDragLeave then begin
    dx := -1;
    dY := -1;
  end else if Abs(dX - aX) + Abs(dY - aY) > 5 then begin
    dX := aX;
    dY := aY;
    TPlayContainer(Parent).DragOverScroll(-1);
  end;
end;



constructor TPlayScroll.Create(aCont:TPlayContainer; aScrW,aHigh:integer);
begin
  inherited Create(aCont);
  Parent := aCont;
  Kind := TScrollBarKind.sbVertical;
  BorderStyle := bsNone;
  Width := aScrW;
  Min := 0;
  Max := 0;
  SmallChange := 1;
  LargeChange := 1;
  Position := 0;
  Enabled := false;
  AnchorSide[akTop].Side := asrTop;
  AnchorSide[akTop].Control := aCont;
  AnchorSide[akRight].Side := asrRight;
  AnchorSide[akRight].Control := aCont;
  AnchorSide[akBottom].Side := asrBottom;
  AnchorSide[akBottom].Control := aCont;
  BorderSpacing.Left := 1;
  BorderSpacing.Top := aHigh;
  BorderSpacing.Right := 1;
  BorderSpacing.Bottom := 1;
  Anchors := [akTop, akRight, akBottom];
  DragMode := dmManual;
  DragKind := dkDrag;
end;

procedure TPlayScroll.Change;
begin
  TPlayContainer(Parent).SetScroller;
end;

procedure TPlayScroll.DragOver(aSource:TObject; aX,aY:Integer; aState: TDragState; var Accept:Boolean);
begin  // der skal kaldes en scroll funktion
  Accept := false;
  if (aY < 20) or (aY > Height - 20) then begin
    if (aState = dsDragEnter) or (dX < 0) or (dY < 0) then begin
      dX := aX;
      dY := aY;
    end else if aState = dsDragLeave then begin
      dx := -1;
      dY := -1;
    end else if Abs(dX - aX) + Abs(dY - aY) > 5 then begin
      dX := aX;
      dY := aY;
      TPlayContainer(Parent).DragOverScroll(BoolSel(aY < 20, -1, 1));
    end;
  end;
end;



constructor TPlayPanel.Create(aCont:TPlayContainer; aLbl:TPlayHeader; aScr:TPlayScroll);
begin
  inherited Create(aCont);
  Parent := aCont;
  AutoSize := false;
  Caption := '';
  BevelInner := bvNone;  // Kan være anderledes...
  BevelOuter := bvNone;
  AnchorSide[akLeft].Side := asrLeft;
  AnchorSide[akLeft].Control := aCont;
  AnchorSide[akTop].Side := asrBottom;
  AnchorSide[akTop].Control := aLbl;
  AnchorSide[akRight].Side := asrLeft;
  AnchorSide[akRight].Control := aScr;
  AnchorSide[akBottom].Side := asrBottom;
  AnchorSide[akBottom].Control := aCont;
  Anchors := [akLeft, akTop, akRight, akBottom];
  DragMode := dmManual;
  DragKind := dkDrag;
  dX := -1;
  dY := -1;
end;

procedure TPlayPanel.DragOver(aSource:TObject; aX,aY:Integer; aState: TDragState; var Accept:Boolean);
begin  // if at bottom, scroll down if possible
  Accept := false;
  if aY > Height - 14 then begin
    if (aState = dsDragEnter) or (dX < 0) or (dY < 0) then begin
      dX := aX;
      dY := aY;
    end else if aState = dsDragLeave then begin
      dx := -1;
      dY := -1;
    end else if Abs(dX - aX) + Abs(dY - aY) > 5 then begin
      dX := aX;
      dY := aY;
      TPlayContainer(Parent).DragOverScroll(1);
    end;
  end;
end;
